#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include "HD44780.h"
#include "rs.h"

volatile char c;

volatile char tab[1000];
volatile char newData;

ISR( INT0_vect )
{
	cli();
	GICR &= ~( 1 << INT0 );
	int i = 0;
	do
	{
		tab[i] = ( (PIND & ( 1 << 3 ) ) ? 1 : 0 );
		_delay_us(111);
		// PORTD ^= ( 1 << 6 );
		if( tab[i] )
			PORTD |= ( 1 << 6 );
		 else
			PORTD &= ~( 1 << 6 );
		i++;
	} while( i < 100 );
	PORTD &=~(1 << 6 );
	// _delay_ms( 1000 );
	newData = 1;
	GICR |= ( 1 << INT0 );
	sei();
}

int main()
{
	rs_initialize();
	LCD_Initialize();
	c = '*';
	newData = 0;
	send_rs_char( '>' );
	send_rs_char( '>' );
	send_rs_char( '>' );

	// Setting up external interrupt from buttons

	MCUCR |= ( 1 << ISC01 );
	GICR |= ( 1 << INT0 );
	DDRD &= ~( 1 << 2 ); // PIND 2 as input...
	DDRD &= ~( 1  << 3 ); // PIND 3 as input
	DDRD |= ( 1 << 6 ); // PIND 6 as output

	sei();
	while(1)
	{
		// _delay_ms( 500 );
		// LCD_WriteData( c );
		if( newData )
		{
			for( int i = 0; i < 100; i++ )
				send_rs_char( 0x30 + tab[i] );
				/*
			int i = 0;
			do
			{
				if( tab[i] )
					PORTD |= ( 1 << 6 );
				else
					PORTD &= ~( 1 << 6 );
				i++;
			} while( i < 100 );
			*/
			newData = 0;
		}
	}
}

